EntityManager = {}

function EntityManager.Init()
	EntityManager.entities = {}
	EntityManager.anEntityHasDied = false
end

function EntityManager.Add(instance)
	local instance = instance
	if instance == nil then
		print("Trying to add an entity to the EntityManager, but the 'instance' argument is not defined! Oh noes! BREAK!")
	
		return 0
	else
		local id = #EntityManager.entities + 1

		EntityManager.entities[id] = instance

		return id 
	end
end

function EntityManager.Update(dt)
	--setup locals for perf
	local enMan = EntityManager
	local tbl = table

	if enMan.anEntityHasDied then
		enMan.anEntityHasDied = false
		for i=#enMan.entities,1,-1 do
			if enMan.entities[i].dead then
				tbl.remove(enMan.entities, i)	
			end
		end
	end

	for i,v in ipairs(enMan.entities) do
		if v.dead == false then
			v:Update(dt)
		end
	end
end

function EntityManager.Draw()
	for i,v in ipairs(EntityManager.entities) do
		v:Draw()
	end
end

function EntityManager.KillAll()
	for i,v in ipairs(EntityManager.entities) do
			v:Kill()
	end
end