PlayerBullet = class('PlayerBullet',Entity) 
local super = Entity

--setup locals for perf
local gfx = love.graphics

local PLAYER_BULLET_DAMAGE = 100
local PLAYER_BULLET_SPEED = 500

function PlayerBullet:initialize(master,x,y,w,h)
	super.initialize(self,x,y)
	self.dir = master.dir or {x = 1, y = 0}
	
	if self.dir.x ~= 0 then 
		self.w = w or 32
		self.h = h or 8
		self.y = self.y + 12
	else
		self.h = w or 32
		self.w = h or 8
		self.x = self.x + 12
	end

	self:SetupBBox("playerBullet", self.x, self.y, self.w, self.h)
end

function PlayerBullet:Update(dt)
	self.x = self.x + (self.dir.x * PLAYER_BULLET_SPEED * dt)
	self.y = self.y + (self.dir.y * PLAYER_BULLET_SPEED * dt)
	self:UpdateBBox()
end

function PlayerBullet:Draw()
	gfx.setColor(50,255,255,255)
	gfx.rectangle("line",self.x,self.y,self.w,self.h)
	gfx.setColor(255,255,255)
end

function PlayerBullet:Kill()
	Pop:new(self.x,self.y,{50,255,255})
	bump.remove(self.bbox)
	super.Kill(self)
end

function PlayerBullet:Collision(collidedWith, dx, dy)
	if collidedWith.name == "wall" then
	  	self:Kill()
	elseif collidedWith.name == "monster" then
	  	self:Kill()
	end
end