Walker = class('Walker',Entity) 
local super = Entity

--setup locals for perf
local gfx = love.graphics

local WALKER_SPEED = 120

function Walker:initialize(x,y)
	super.initialize(self,x,y)
	self:SetupBBox("monster", self.x, self.y, 16, 32)
	self.dir = {x = 0, y = 0}
	self:RandomDirection()
	self.xprev = self.x
	self.yprev = self.y
end

function Walker:Update(dt)
	self.xprev = self.x
	self.yprev = self.y

	self.x = self.x + (WALKER_SPEED * self.dir.x * dt)
	self.y = self.y + (WALKER_SPEED * self.dir.y * dt)

	self:UpdateBBox()
end

function Walker:Draw()
	--love.graphics.drawq(img2, diffuse2, self.x, self.y)
	gfx.setColor(150,255,150)
	gfx.rectangle("line",self.x,self.y,16,32)
	gfx.setColor(255,255,255)
end

function Walker:Kill()
	Pop:new(self.x+6,self.y+12,{150,255,255})
	bump.remove(self.bbox)
	super.Kill(self)
end

function Walker:Collision(collidedWith, dx, dy)
	if collidedWith.name == "playerSword" then
	  	self:Kill()
	elseif collidedWith.name == "playerBullet" then
	  	self:Kill()
	elseif ((collidedWith.name == "wall") or (collidedWith.name == "monster")) then
		self.x = self.xprev
		self.y = self.yprev
		self:RandomDirection(true)
	end
end

function Walker:RandomDirection(onlyNinety)
	local onlyNinety = onlyNinety or false

	if not onlyNinety then
		self.dir = {x = math.floor(math.random(-1,1)),y = math.floor(math.random(-1,1))}
		if ((self.dir.x ~= 0) and (self.dir.y ~= 0)) then
			self.dir.x = self.dir.x * 0.6666667
			self.dir.y = self.dir.y * 0.6666667
		elseif ((self.dir.x == 0) and (self.dir.y == 0)) then
			local rnd = math.random(1,100)
			if (rnd >= 75) then self.dir.x = 1
			elseif ((rnd >= 50) and (rnd < 75)) then self.dir.x = -1
			elseif ((rnd >= 25) and (rnd < 50)) then self.dir.y = -1
			else self.dir.y = 1 end
		end
	else
		local rnd = math.random(1,100)
		self.dir = {x = 0, y = 0}
		if (rnd >= 75) then self.dir.x = 1
		elseif ((rnd >= 50) and (rnd < 75)) then self.dir.x = -1
		elseif ((rnd >= 25) and (rnd < 50)) then self.dir.y = -1
		else self.dir.y = 1 end
	end
end