cBump = {}

function cBump:SetupBBox(name, x, y, w, h)
	local name = name or "entity"
	local bbX = x or self.x
	local bbY = y or self.y
	local bbW = w or 32
	local bbH = h or 32
	self.bbox = {name = name, l = bbX , t = bbY, w = bbW, h = bbH, owner = self}
	bump.add(self.bbox)
end

function cBump:UpdateBBox()
	self.bbox.l = self.x
	self.bbox.t = self.y
end

function cBump:Collision(collidedWith, dx, dy)
	--print(self.bbox.name.." is colliding with "..collidedWith.name.." dx: "..dx.." dy: "..dy)
end

function cBump:EndCollision(collidedWith)
	--print(self.bbox.name.." stopped colliding with "..collidedWith.name)
end

function cBump:DrawBBox()
	love.graphics.setColor(255,0,0)
	love.graphics.rectangle("line",self.bbox.l,self.bbox.t,self.bbox.w,self.bbox.h)
	love.graphics.setColor(255,255,255)
end

function cBump:Kill()
	self.class.super.Kill(self)
end

function bump.collision(obj1, obj2, dx, dy)
  if obj1.owner ~= nil then obj1.owner:Collision(obj2,  dx,  dy) end
  if obj2.owner ~= nil then obj2.owner:Collision(obj1, -dx, -dy) end
end

function bump.endCollision(obj1, obj2)
  if obj1.owner ~= nil then obj1.owner:EndCollision(obj2) end
  if obj2.owner ~= nil then obj2.owner:EndCollision(obj1) end
end

function bump.getBBox(item)
  return item.l, item.t, item.w, item.h
end