LevelLoader = {}

function LevelLoader.LoadLevel(lvl)
	--setup locals for optimization
	local bp = bump
	local fTSB = floorTileSpritebatch
	
	PL = nil
	fTSB:clear()

	bp.initialize(64)

	local lvl = lvl or 1
	currentLevel = lvl
	chunk = love.filesystem.load("levels/"..lvl..".dmlvl")
	chunk()
	tilemap = loadedTilemap

	bp.addStatic({name = "wall", l = -2, t = -2, w = 2, h = 708})
	bp.addStatic({name = "wall", l = 992, t = -2, w = 2, h = 708})
	bp.addStatic({name = "wall", l = -2, t = -2, w = 996, h = 2})
	bp.addStatic({name = "wall", l = -2, t = 704, w = 996, h = 2})

	for tx=1,TILEMAP_WIDTH do
		for ty=1,TILEMAP_HEIGHT do
			local dX = tx * grid.cellSize - grid.cellSize + TILEMAP_X
			local dY = ty * grid.cellSize - grid.cellSize + TILEMAP_Y
			if tilemap[ty][tx] == "X" then
				bp.addStatic({name = "wall", l = dX, t = dY, w = grid.cellSize, h = grid.cellSize})
			else
				fTSB:add(dX-1,dY-1,0,1.0625,1.0625)
			end

			if tilemap[ty][tx] == "walker" then
				Walker:new(dX,dY)
			elseif tilemap[ty][tx] == "player" then
				PL = Player:new(dX,dY,"Dungeon Man")
			elseif tilemap[ty][tx] == "exit" then
				Exit:new(dX,dY)
			end
		end
	end

	print("Entity count: "..#EntityManager.entities)

end

function LevelLoader.ChangeLevel(lvl)
	EntityManager.KillAll()
	LevelLoader.LoadLevel(lvl)
end